Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hsqldb.jdbc
Class jdbcDatabaseMetaData

    java.lang.Object
      org.hsqldb.jdbc.jdbcDatabaseMetaData

All Implemented Interfaces:
  java.sql.DatabaseMetaData, java.sql.Wrapper

    public class jdbcDatabaseMetaData

extends java.lang.Object
implements java.sql.DatabaseMetaData

Comprehensive information about the database as a whole.

This interface is implemented by driver vendors to let users know the capabilities of a Database Management System (DBMS) in combination with the driver based on JDBCTM technology ("JDBC driver") that is used with it. Different relational DBMSs often support different features, implement features in different ways, and use different data types. In addition, a driver may implement a feature on top of what the DBMS offers. Information returned by methods in this interface applies to the capabilities of a particular driver and a particular DBMS working together. Note that as used in this documentation, the term "database" is used generically to refer to both the driver and DBMS.

A user for this interface is commonly a tool that needs to discover how to deal with the underlying DBMS. This is especially true for applications that are intended to be used with more than one DBMS. For example, a tool might use the method `getTypeInfo` to find out what data types can be used in a `CREATE TABLE` statement. Or a user might call the method `supportsCorrelatedSubqueries` to see if it is possible to use a correlated subquery or `supportsBatchUpdates` to see if it is possible to use batch updates.

Some `DatabaseMetaData` methods return lists of information in the form of `ResultSet` objects. Regular `ResultSet` methods, such as `getString` and `getInt`, can be used to retrieve the data from these `ResultSet` objects. If a given form of metadata is not available, the `ResultSet` getter methods throw an `SQLException`.

Some `DatabaseMetaData` methods take arguments that are String patterns. These arguments all have names such as fooPattern. Within a pattern String, "%" means match any substring of 0 or more characters, and "_" means match any one character. Only metadata entries matching the search pattern are returned. If a search pattern argument is set to `null`, that argument's criterion will be dropped from the search.

A method that gets information about a feature that the driver does not support will throw an `SQLException`. In the case of methods that return a `ResultSet` object, either a `ResultSet` object (which may be empty) is returned or an `SQLException` is thrown.

### HSQLDB-Specific Information:

Starting with HSQLDB 1.7.2, an option is provided to allow alternate system table production implementations. In this distribution, there are three implementations whose behaviour ranges from producing no system tables at all to producing a richer and more complete body of information about an HSQLDB database than was previously available. The information provided through the default implementation is, unlike previous versions, accessible to all database users, regardless of admin status. This is now possible because the table content it produces for each user is pre-filtered, based on the user's access rights. That is, each system table now acts like a security-aware View.

The process of installing a system table production class is transparent and occurs dynamically at runtime during the opening sequence of a `Database` instance, in the newDatabaseInformation() factory method of the revised DatabaseInformation class, using the following steps:

1. If a class whose fully qualified name is org.hsqldb.DatabaseInformationFull can be found and it has an accesible constructor that takes an org.hsqldb.Database object as its single parameter, then an instance of that class is reflectively instantiated and is used by the database instance to produce its system tables.

2. If 1.) fails, then the process is repeated, attempting to create an instance of org.hsqldb.DatabaseInformationMain (which provides just the core set of system tables required to service this class, but now does so in a more security aware and comprehensive fashion).

3. If 2.) fails, then an instance of org.hsqldb.DatabaseInformation is installed (that, by default, produces no system tables, meaning that calls to all related methods in this class will fail, throwing an SQLException stating that a required system table is not found).

The process of searching for alternate implementations of database support classes, ending with the installation of a minimal but functional default will be refered to henceforth as graceful degradation. This process is advantageous in that it allows developers and administrators to easily choose packaging options, simply by adding to or deleting concerned classes from an HSQLDB installation, without worry over providing complex initialization properties or disrupting the core operation of the engine. In this particular context, graceful degradation allows easy choices regarding database metadata, spanning the range of full (design-time), custom-written, minimal (production-time) or `null` (space-constrained) system table production implementations.

In the default full implementation, a number of new system tables are provided that, although not used directly by this class, present previously unavailable information about the database, such as about its triggers and aliases.

In order to better support graphical database exploration tools and as an experimental intermediate step toward more fully supporting SQL9n and SQL200n, the default installed DatabaseInformation implementation is also capable of reporting pseudo name space information, such as the catalog (database URI) of database objects.

The catalog reporting feature is turned off by default but can be turned on by providing the appropriate entries in the database properties file (see the advanced topics section of the product documentation).

When the feature is turned on, catalog is reported using the following conventions:

1. All objects are reported as having a catalog equal to the URI of the database, which is equivalent to the catenation of the <type> and <path> portions of the HSQLDB internal JDBC connection URL.

   Examples:

            "jdbc:hsqldb:file:test"      => "file:test"
            "jdbc:hsqldb:mem:."          => "mem:."
            "jdbc:hsqldb:hsql:/host/..." => URI of aliased database
            "jdbc:hsqldb:http:/host/..." => URI of aliased database

   Note: No provision is made for qualifying database objects by catalog in DML or DDL SQL. This feature is functional only with respect to browsing the database through the DatabaseMetaData and system table interfaces.

Again, it should be well understood that this feature provide an emulation of catalog support and is intended only as an experimental implementation to enhance the browsing experience when using graphical database explorers and to make a first foray into tackling the issue of implementing true catalog support in the future.

Due the nature of the new database system table production process, fewer assumptions can be made by this class about what information is made available in the system tables supporting `DatabaseMetaData` methods. Because of this, the SQL queries behind the `ResultSet` producing methods have been cleaned up and made to adhere more strictly to the JDBC contracts specified in relation to the method parameters.

One of the remaining assumptions concerns the `approximate` argument of `getIndexInfo()`. This parameter is still ignored since there is not yet any process in place to internally gather and persist table and index statistics. A primitive version of a statistics gathering and reporting subsystem may be introduced some time in the 1.7.x series of releases, but no hard decision has yet been made.

Another assumption is that simple select queries against certain system tables will return rows in JDBC contract order in the absence of an "ORDER BY" clause. The reason for this is that results come back much faster when no "ORDER BY" clause is used. Developers wishing to extend or replace an existing system table production class should be aware of this, either adding the contract "ORDER BY" clause to the SQL in corresponding methods in this class, or, better, by maintaing rows in the correct order in the underlying system tables, prefereably by creating appropriate primary indices.

JRE 1.1.x Notes:

In general, JDBC 2 support requires Java 1.2 and above, and JDBC3 requires Java 1.4 and above. In HSQLDB, support for methods introduced in different versions of JDBC depends on the JDK version used for compiling and building HSQLDB.

Since 1.7.0, it is possible to build the product so that all JDBC 2 methods can be called while executing under the version 1.1.x Java Runtime EnvironmentTM. However, some of these method calls require `int` values that are defined only in the JDBC 2 or greater version of the `ResultSet` interface. For this reason, when the product is compiled under JDK 1.1.x, these values are defined in `jdbcResultSet`.

In a JRE 1.1.x environment, calling JDBC 2 methods that take or return the JDBC2-only `ResultSet` values can be achieved by referring to them in parameter specifications and return value comparisons, respectively, as follows:

     jdbcResultSet.FETCH_FORWARD
     jdbcResultSet.TYPE_FORWARD_ONLY
     jdbcResultSet.TYPE_SCROLL_INSENSITIVE
     jdbcResultSet.CONCUR_READ_ONLY
     // etc

However, please note that code written in such a manner will not be compatible for use with other JDBC 2 drivers, since they expect and use `ResultSet`, rather than `jdbcResultSet`. Also note, this feature is offered solely as a convenience to developers who must work under JDK 1.1.x due to operating constraints, yet wish to use some of the more advanced features available under the JDBC 2 specification.

(fredt@users)
(boucherb@users)

Author:
  boucherb@users, fredt@users
See Also:
  `DatabaseInformation`, `DatabaseInformationMain`, `DatabaseInformationFull`

Field Summary

Fields inherited from interface java.sql.DatabaseMetaData
`attributeNoNulls, attributeNullable, attributeNullableUnknown, bestRowNotPseudo, bestRowPseudo, bestRowSession, bestRowTemporary, bestRowTransaction, bestRowUnknown, columnNoNulls, columnNullable, columnNullableUnknown, functionColumnIn, functionColumnInOut, functionColumnOut, functionColumnResult, functionColumnUnknown, functionNoNulls, functionNoTable, functionNullable, functionNullableUnknown, functionResultUnknown, functionReturn, functionReturnsTable, importedKeyCascade, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeyRestrict, importedKeySetDefault, importedKeySetNull, procedureColumnIn, procedureColumnInOut, procedureColumnOut, procedureColumnResult, procedureColumnReturn, procedureColumnUnknown, procedureNoNulls, procedureNoResult, procedureNullable, procedureNullableUnknown, procedureResultUnknown, procedureReturnsResult, sqlStateSQL, sqlStateSQL99, sqlStateXOpen, tableIndexClustered, tableIndexHashed, tableIndexOther, tableIndexStatistic, typeNoNulls, typeNullable, typeNullableUnknown, typePredBasic, typePredChar, typePredNone, typeSearchable, versionColumnNotPseudo, versionColumnPseudo, versionColumnUnknown`

Method Summary
`boolean` | `allProceduresAreCallable()` Retrieves whether the current user can call all the procedures returned by the method `getProcedures`.
`boolean` | `allTablesAreSelectable()` Retrieves whether the current user can use all the tables returned by the method `getTables` in a `SELECT` statement.
`boolean` | `dataDefinitionCausesTransactionCommit()` Retrieves whether a data definition statement within a transaction forces the transaction to commit.
`boolean` | `dataDefinitionIgnoredInTransactions()` Retrieves whether this database ignores a data definition statement within a transaction.
`boolean` | `deletesAreDetected(int type)` Retrieves whether or not a visible row delete can be detected by calling the method `ResultSet.rowDeleted`.
`boolean` | `doesMaxRowSizeIncludeBlobs()` Retrieves whether the return value for the method `getMaxRowSize` includes the SQL data types `LONGVARCHAR` and `LONGVARBINARY`.
`java.sql.ResultSet` | `getAttributes(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String typeNamePattern, java.lang.String attributeNamePattern)` Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog.
`java.sql.ResultSet` | `getBestRowIdentifier(java.lang.String catalog, java.lang.String schema, java.lang.String table, int scope, boolean nullable)` Retrieves a description of a table's optimal set of columns that uniquely identifies a row.
`java.sql.ResultSet` | `getCatalogs()` Retrieves the catalog names available in this database.
`java.lang.String` | `getCatalogSeparator()` Retrieves the `String` that this database uses as the separator between a catalog and table name.
`java.lang.String` | `getCatalogTerm()` Retrieves the database vendor's preferred term for "catalog".
`java.sql.ResultSet` | `getColumnPrivileges(java.lang.String catalog, java.lang.String schema, java.lang.String table, java.lang.String columnNamePattern)` Retrieves a description of the access rights for a table's columns.
`java.sql.ResultSet` | `getColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern, java.lang.String columnNamePattern)` Retrieves a description of table columns available in the specified catalog.
`java.sql.Connection` | `getConnection()` Retrieves the connection that produced this metadata object.
`java.sql.ResultSet` | `getCrossReference(java.lang.String primaryCatalog, java.lang.String primarySchema, java.lang.String primaryTable, java.lang.String foreignCatalog, java.lang.String foreignSchema, java.lang.String foreignTable)` Retrieves a description of the foreign key columns in the given foreign key table that reference the primary key columns of the given primary key table (describe how one table imports another's key).
`int` | `getDatabaseMajorVersion()` Retrieves the major version number of the underlying database.
`int` | `getDatabaseMinorVersion()` Retrieves the minor version number of the underlying database.
`java.lang.String` | `getDatabaseProductName()` Retrieves the name of this database product.
`java.lang.String` | `getDatabaseProductVersion()` Retrieves the version number of this database product.
`int` | `getDefaultTransactionIsolation()` Retrieves this database's default transaction isolation level.
`int` | `getDriverMajorVersion()` Retrieves this JDBC driver's major version number.
`int` | `getDriverMinorVersion()` Retrieves this JDBC driver's minor version number.
`java.lang.String` | `getDriverName()` Retrieves the name of this JDBC driver.
`java.lang.String` | `getDriverVersion()` Retrieves the version number of this JDBC driver as a `String`.
`java.sql.ResultSet` | `getExportedKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Retrieves a description of the foreign key columns that reference the given table's primary key columns (the foreign keys exported by a table).
`java.lang.String` | `getExtraNameCharacters()` Retrieves all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).
`java.lang.String` | `getIdentifierQuoteString()` Retrieves the string used to quote SQL identifiers.
`java.sql.ResultSet` | `getImportedKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Retrieves a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table).
`java.sql.ResultSet` | `getIndexInfo(java.lang.String catalog, java.lang.String schema, java.lang.String table, boolean unique, boolean approximate)` Retrieves a description of the given table's indices and statistics.
`int` | `getJDBCMajorVersion()` Retrieves the major JDBC version number for this driver.
`int` | `getJDBCMinorVersion()` Retrieves the minor JDBC version number for this driver.
`int` | `getMaxBinaryLiteralLength()` Retrieves the maximum number of hex characters this database allows in an inline binary literal.
`int` | `getMaxCatalogNameLength()` Retrieves the maximum number of characters that this database allows in a catalog name.
`int` | `getMaxCharLiteralLength()` Retrieves the maximum number of characters this database allows for a character literal.
`int` | `getMaxColumnNameLength()` Retrieves the maximum number of characters this database allows for a column name.
`int` | `getMaxColumnsInGroupBy()` Retrieves the maximum number of columns this database allows in a `GROUP BY` clause.
`int` | `getMaxColumnsInIndex()` Retrieves the maximum number of columns this database allows in an index.
`int` | `getMaxColumnsInOrderBy()` Retrieves the maximum number of columns this database allows in an `ORDER BY` clause.
`int` | `getMaxColumnsInSelect()` Retrieves the maximum number of columns this database allows in a `SELECT` list.
`int` | `getMaxColumnsInTable()` Retrieves the maximum number of columns this database allows in a table.
`int` | `getMaxConnections()` Retrieves the maximum number of concurrent connections to this database that are possible.
`int` | `getMaxCursorNameLength()` Retrieves the maximum number of characters that this database allows in a cursor name.
`int` | `getMaxIndexLength()` Retrieves the maximum number of bytes this database allows for an index, including all of the parts of the index.
`int` | `getMaxProcedureNameLength()` Retrieves the maximum number of characters that this database allows in a procedure name.
`int` | `getMaxRowSize()` Retrieves the maximum number of bytes this database allows in a single row.
`int` | `getMaxSchemaNameLength()` Retrieves the maximum number of characters that this database allows in a schema name.
`int` | `getMaxStatementLength()` Retrieves the maximum number of characters this database allows in an SQL statement.
`int` | `getMaxStatements()` Retrieves the maximum number of active statements to this database that can be open at the same time.
`int` | `getMaxTableNameLength()` Retrieves the maximum number of characters this database allows in a table name.
`int` | `getMaxTablesInSelect()` Retrieves the maximum number of tables this database allows in a `SELECT` statement.
`int` | `getMaxUserNameLength()` Retrieves the maximum number of characters this database allows in a user name.
`java.lang.String` | `getNumericFunctions()` Retrieves a comma-separated list of math functions available with this database.
`java.sql.ResultSet` | `getPrimaryKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Retrieves a description of the given table's primary key columns.
`java.sql.ResultSet` | `getProcedureColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureNamePattern, java.lang.String columnNamePattern)` Retrieves a description of the given catalog's stored procedure parameter and result columns.
`java.sql.ResultSet` | `getProcedures(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureNamePattern)` Retrieves a description of the stored procedures available in the given catalog.
`java.lang.String` | `getProcedureTerm()` Retrieves the database vendor's preferred term for "procedure".
`int` | `getResultSetHoldability()` Retrieves the default holdability of this `ResultSet` object.
`java.sql.ResultSet` | `getSchemas()` Retrieves the schema names available in this database.
`java.lang.String` | `getSchemaTerm()` Retrieves the database vendor's preferred term for "schema".
`java.lang.String` | `getSearchStringEscape()` Retrieves the string that can be used to escape wildcard characters.
`java.lang.String` | `getSQLKeywords()` Retrieves a comma-separated list of all of this database's SQL keywords that are NOT also SQL92 keywords.
`int` | `getSQLStateType()` Indicates whether the SQLSTATEs returned by `SQLException.getSQLState` is X/Open (now known as Open Group) SQL CLI or SQL99.
`java.lang.String` | `getStringFunctions()` Retrieves a comma-separated list of string functions available with this database.
`java.sql.ResultSet` | `getSuperTables(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern)` Retrieves a description of the table hierarchies defined in a particular schema in this database.
`java.sql.ResultSet` | `getSuperTypes(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String typeNamePattern)` Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database.
`java.lang.String` | `getSystemFunctions()` Retrieves a comma-separated list of system functions available with this database.
`java.sql.ResultSet` | `getTablePrivileges(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern)` Retrieves a description of the access rights for each table available in a catalog.
`java.sql.ResultSet` | `getTables(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern, java.lang.String[] types)` Retrieves a description of the tables available in the given catalog.
`java.sql.ResultSet` | `getTableTypes()` Retrieves the table types available in this database.
`java.lang.String` | `getTimeDateFunctions()` Retrieves a comma-separated list of the time and date functions available with this database.
`java.sql.ResultSet` | `getTypeInfo()` Retrieves a description of all the standard SQL types supported by this database.
`java.sql.ResultSet` | `getUDTs(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String typeNamePattern, int[] types)` Retrieves a description of the user-defined types (UDTs) defined in a particular schema.
`java.lang.String` | `getURL()` Retrieves the URL for this DBMS.
`java.lang.String` | `getUserName()` Retrieves the user name as known to this database.
`java.sql.ResultSet` | `getVersionColumns(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Retrieves a description of a table's columns that are automatically updated when any value in a row is updated.
`boolean` | `insertsAreDetected(int type)` Retrieves whether or not a visible row insert can be detected by calling the method `ResultSet.rowInserted`.
`boolean` | `isCatalogAtStart()` Retrieves whether a catalog appears at the start of a fully qualified table name.
`boolean` | `isReadOnly()` Retrieves whether this database is in read-only mode.
`boolean` | `locatorsUpdateCopy()` Indicates whether updates made to a LOB are made on a copy or directly to the LOB.
`boolean` | `nullPlusNonNullIsNull()` Retrieves whether this database supports concatenations between `NULL` and non-`NULL` values being `NULL`.
`boolean` | `nullsAreSortedAtEnd()` Retrieves whether `NULL` values are sorted at the end regardless of sort order.
`boolean` | `nullsAreSortedAtStart()` Retrieves whether `NULL` values are sorted at the start regardless of sort order.
`boolean` | `nullsAreSortedHigh()` Retrieves whether `NULL` values are sorted high.
`boolean` | `nullsAreSortedLow()` Retrieves whether `NULL` values are sorted low.
`boolean` | `othersDeletesAreVisible(int type)` Retrieves whether deletes made by others are visible.
`boolean` | `othersInsertsAreVisible(int type)` Retrieves whether inserts made by others are visible.
`boolean` | `othersUpdatesAreVisible(int type)` Retrieves whether updates made by others are visible.
`boolean` | `ownDeletesAreVisible(int type)` Retrieves whether a result set's own deletes are visible.
`boolean` | `ownInsertsAreVisible(int type)` Retrieves whether a result set's own inserts are visible.
`boolean` | `ownUpdatesAreVisible(int type)` Retrieves whether for the given type of `ResultSet` object, the result set's own updates are visible.
`boolean` | `storesLowerCaseIdentifiers()` Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in lower case.
`boolean` | `storesLowerCaseQuotedIdentifiers()` Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in lower case.
`boolean` | `storesMixedCaseIdentifiers()` Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in mixed case.
`boolean` | `storesMixedCaseQuotedIdentifiers()` Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in mixed case.
`boolean` | `storesUpperCaseIdentifiers()` Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in upper case.
`boolean` | `storesUpperCaseQuotedIdentifiers()` Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in upper case.
`boolean` | `supportsAlterTableWithAddColumn()` Retrieves whether this database supports `ALTER TABLE` with add column.
`boolean` | `supportsAlterTableWithDropColumn()` Retrieves whether this database supports `ALTER TABLE` with drop column.
`boolean` | `supportsANSI92EntryLevelSQL()` Retrieves whether this database supports the ANSI92 entry level SQL grammar.
`boolean` | `supportsANSI92FullSQL()` Retrieves whether this database supports the ANSI92 full SQL grammar supported.
`boolean` | `supportsANSI92IntermediateSQL()` Retrieves whether this database supports the ANSI92 intermediate SQL grammar supported.
`boolean` | `supportsBatchUpdates()` Retrieves whether this database supports batch updates.
`boolean` | `supportsCatalogsInDataManipulation()` Retrieves whether a catalog name can be used in a data manipulation statement.
`boolean` | `supportsCatalogsInIndexDefinitions()` Retrieves whether a catalog name can be used in an index definition statement.
`boolean` | `supportsCatalogsInPrivilegeDefinitions()` Retrieves whether a catalog name can be used in a privilege definition statement.
`boolean` | `supportsCatalogsInProcedureCalls()` Retrieves whether a catalog name can be used in a procedure call statement.
`boolean` | `supportsCatalogsInTableDefinitions()` Retrieves whether a catalog name can be used in a table definition statement.
`boolean` | `supportsColumnAliasing()` Retrieves whether this database supports column aliasing.
`boolean` | `supportsConvert()` Retrieves whether this database supports the `CONVERT` function between SQL types.
`boolean` | `supportsConvert(int fromType, int toType)` Retrieves whether this database supports the `CONVERT` for two given SQL types.
`boolean` | `supportsCoreSQLGrammar()` Retrieves whether this database supports the ODBC Core SQL grammar.
`boolean` | `supportsCorrelatedSubqueries()` Retrieves whether this database supports correlated subqueries.
`boolean` | `supportsDataDefinitionAndDataManipulationTransactions()` Retrieves whether this database supports both data definition and data manipulation statements within a transaction.
`boolean` | `supportsDataManipulationTransactionsOnly()` Retrieves whether this database supports only data manipulation statements within a transaction.
`boolean` | `supportsDifferentTableCorrelationNames()` Retrieves whether, when table correlation names are supported, they are restricted to being different from the names of the tables.
`boolean` | `supportsExpressionsInOrderBy()` Retrieves whether this database supports expressions in `ORDER BY` lists.
`boolean` | `supportsExtendedSQLGrammar()` Retrieves whether this database supports the ODBC Extended SQL grammar.
`boolean` | `supportsFullOuterJoins()` Retrieves whether this database supports full nested outer joins.
`boolean` | `supportsGetGeneratedKeys()` Retrieves whether auto-generated keys can be retrieved after a statement has been executed.
`boolean` | `supportsGroupBy()` Retrieves whether this database supports some form of `GROUP BY` clause.
`boolean` | `supportsGroupByBeyondSelect()` Retrieves whether this database supports using columns not included in the `SELECT` statement in a `GROUP BY` clause provided that all of the columns in the `SELECT` statement are included in the `GROUP BY` clause.
`boolean` | `supportsGroupByUnrelated()` Retrieves whether this database supports using a column that is not in the `SELECT` statement in a `GROUP BY` clause.
`boolean` | `supportsIntegrityEnhancementFacility()` Retrieves whether this database supports the SQL Integrity Enhancement Facility.
`boolean` | `supportsLikeEscapeClause()` Retrieves whether this database supports specifying a `LIKE` escape clause.
`boolean` | `supportsLimitedOuterJoins()` Retrieves whether this database provides limited support for outer joins.
`boolean` | `supportsMinimumSQLGrammar()` Retrieves whether this database supports the ODBC Minimum SQL grammar.
`boolean` | `supportsMixedCaseIdentifiers()` Retrieves whether this database treats mixed case unquoted SQL identifiers as case sensitive and as a result stores them in mixed case.
`boolean` | `supportsMixedCaseQuotedIdentifiers()` Retrieves whether this database treats mixed case quoted SQL identifiers as case sensitive and as a result stores them in mixed case.
`boolean` | `supportsMultipleOpenResults()` Retrieves whether it is possible to have multiple `ResultSet` objects returned from a `CallableStatement` object simultaneously.
`boolean` | `supportsMultipleResultSets()` Retrieves whether this database supports getting multiple `ResultSet` objects from a single call to the method `execute`.
`boolean` | `supportsMultipleTransactions()` Retrieves whether this database allows having multiple transactions open at once (on different connections).
`boolean` | `supportsNamedParameters()` Retrieves whether this database supports named parameters to callable statements.
`boolean` | `supportsNonNullableColumns()` Retrieves whether columns in this database may be defined as non-nullable.
`boolean` | `supportsOpenCursorsAcrossCommit()` Retrieves whether this database supports keeping cursors open across commits.
`boolean` | `supportsOpenCursorsAcrossRollback()` Retrieves whether this database supports keeping cursors open across rollbacks.
`boolean` | `supportsOpenStatementsAcrossCommit()` Retrieves whether this database supports keeping statements open across commits.
`boolean` | `supportsOpenStatementsAcrossRollback()` Retrieves whether this database supports keeping statements open across rollbacks.
`boolean` | `supportsOrderByUnrelated()` Retrieves whether this database supports using a column that is not in the `SELECT` statement in an `ORDER BY` clause.
`boolean` | `supportsOuterJoins()` Retrieves whether this database supports some form of outer join.
`boolean` | `supportsPositionedDelete()` Retrieves whether this database supports positioned `DELETE` statements.
`boolean` | `supportsPositionedUpdate()` Retrieves whether this database supports positioned `UPDATE` statements.
`boolean` | `supportsResultSetConcurrency(int type, int concurrency)` Retrieves whether this database supports the given concurrency type in combination with the given result set type.
`boolean` | `supportsResultSetHoldability(int holdability)` Retrieves whether this database supports the given result set holdability.
`boolean` | `supportsResultSetType(int type)` Retrieves whether this database supports the given result set type.
`boolean` | `supportsSavepoints()` Retrieves whether this database supports savepoints.
`boolean` | `supportsSchemasInDataManipulation()` Retrieves whether a schema name can be used in a data manipulation statement.
`boolean` | `supportsSchemasInIndexDefinitions()` Retrieves whether a schema name can be used in an index definition statement.
`boolean` | `supportsSchemasInPrivilegeDefinitions()` Retrieves whether a schema name can be used in a privilege definition statement.
`boolean` | `supportsSchemasInProcedureCalls()` Retrieves whether a schema name can be used in a procedure call statement.
`boolean` | `supportsSchemasInTableDefinitions()` Retrieves whether a schema name can be used in a table definition statement.
`boolean` | `supportsSelectForUpdate()` Retrieves whether this database supports `SELECT FOR UPDATE` statements.
`boolean` | `supportsStatementPooling()` Retrieves whether this database supports statement pooling.
`boolean` | `supportsStoredProcedures()` Retrieves whether this database supports stored procedure calls that use the stored procedure escape syntax.
`boolean` | `supportsSubqueriesInComparisons()` Retrieves whether this database supports subqueries in comparison expressions.
`boolean` | `supportsSubqueriesInExists()` Retrieves whether this database supports subqueries in `EXISTS` expressions.
`boolean` | `supportsSubqueriesInIns()` JDBC4 correction: Retrieves whether this database supports subqueries in `IN` expressions.
`boolean` | `supportsSubqueriesInQuantifieds()` Retrieves whether this database supports subqueries in quantified expressions.
`boolean` | `supportsTableCorrelationNames()` Retrieves whether this database supports table correlation names.
`boolean` | `supportsTransactionIsolationLevel(int level)` Retrieves whether this database supports the given transaction isolation level.
`boolean` | `supportsTransactions()` Retrieves whether this database supports transactions.
`boolean` | `supportsUnion()` Retrieves whether this database supports SQL `UNION`.
`boolean` | `supportsUnionAll()` Retrieves whether this database supports SQL `UNION ALL`.
`boolean` | `updatesAreDetected(int type)` Retrieves whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.
`boolean` | `usesLocalFilePerTable()` Retrieves whether this database uses a file for each table.
`boolean` | `usesLocalFiles()` Retrieves whether this database stores tables in a local file.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.sql.DatabaseMetaData
`autoCommitFailureClosesAllResultSets, getClientInfoProperties, getFunctionColumns, getFunctions, getRowIdLifetime, getSchemas, supportsStoredFunctionsUsingCallSyntax`

Methods inherited from interface java.sql.Wrapper
`isWrapperFor, unwrap`

Method Detail

### allProceduresAreCallable

    public boolean allProceduresAreCallable()
                                     throws java.sql.SQLException

  Retrieves whether the current user can call all the procedures returned by the method `getProcedures`.

  ### HSQLDB-Specific Information:

  This method still always returns `true`.

  In a future release, the plugin interface may be modified to allow implementors to report different values here, based on their implementations.

  Specified by:
    `allProceduresAreCallable` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### allTablesAreSelectable

    public boolean allTablesAreSelectable()
                                   throws java.sql.SQLException

  Retrieves whether the current user can use all the tables returned by the method `getTables` in a `SELECT` statement.

  ### HSQLDB-Specific Information:

  HSQLDB always reports `true`.

  Please note that the default 1.7.2 `getTables` behaviour is omit from the list of requested tables only those to which the invoking user has no access of any kind.

  Specified by:
    `allTablesAreSelectable` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getURL

    public java.lang.String getURL()
                            throws java.sql.SQLException

  Retrieves the URL for this DBMS.

  Specified by:
    `getURL` in interface `java.sql.DatabaseMetaData`
  Returns:
    the URL for this DBMS or `null` if it cannot be generated
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getUserName

    public java.lang.String getUserName()
                                 throws java.sql.SQLException

  Retrieves the user name as known to this database.

  Specified by:
    `getUserName` in interface `java.sql.DatabaseMetaData`
  Returns:
    the database user name
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### isReadOnly

    public boolean isReadOnly()
                       throws java.sql.SQLException

  Retrieves whether this database is in read-only mode.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, this makes an SQL call to the new `Library.isReadOnlyDatabase` method which provides correct determination of the read-only status for both local and remote database instances.

  Specified by:
    `isReadOnly` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### nullsAreSortedHigh

    public boolean nullsAreSortedHigh()
                               throws java.sql.SQLException

  Retrieves whether `NULL` values are sorted high. Sorted high means that `NULL` values sort higher than any other value in a domain. In an ascending order, if this method returns `true`, `NULL` values will appear at the end. By contrast, the method `nullsAreSortedAtEnd` indicates whether `NULL` values are sorted at the end regardless of sort order.

  ### HSQLDB-Specific Information:

  HSQLDB sorts null low; this method always returns `false`.

  Specified by:
    `nullsAreSortedHigh` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### nullsAreSortedLow

    public boolean nullsAreSortedLow()
                              throws java.sql.SQLException

  Retrieves whether `NULL` values are sorted low. Sorted low means that `NULL` values sort lower than any other value in a domain. In an ascending order, if this method returns `true`, `NULL` values will appear at the beginning. By contrast, the method `nullsAreSortedAtStart` indicates whether `NULL` values are sorted at the beginning regardless of sort order.

  ### HSQLDB-Specific Information:

  HSQLDB sorts null low; this method always returns `true`.

  Specified by:
    `nullsAreSortedLow` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### nullsAreSortedAtStart

    public boolean nullsAreSortedAtStart()
                                  throws java.sql.SQLException

  Retrieves whether `NULL` values are sorted at the start regardless of sort order.

  ### HSQLDB-Specific Information:

  HSQLDB sorts null low; this method always returns `false`.

  Specified by:
    `nullsAreSortedAtStart` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### nullsAreSortedAtEnd

    public boolean nullsAreSortedAtEnd()
                                throws java.sql.SQLException

  Retrieves whether `NULL` values are sorted at the end regardless of sort order.

  ### HSQLDB-Specific Information:

  HSQLDB sorts null low; this method always returns `false`.

  Specified by:
    `nullsAreSortedAtEnd` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getDatabaseProductName

    public java.lang.String getDatabaseProductName()
                                            throws java.sql.SQLException

  Retrieves the name of this database product.

  ### HSQLDB-Specific Information:

  Starting with HSQLDB 1.7.2, this value is retrieved through an SQL call to the new `Library.getDatabaseProductName` method which allows correct determination of the database product name for both local and remote database instances.

  Specified by:
    `getDatabaseProductName` in interface `java.sql.DatabaseMetaData`
  Returns:
    database product name
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getDatabaseProductVersion

    public java.lang.String getDatabaseProductVersion()
                                               throws java.sql.SQLException

  Retrieves the version number of this database product.

  ### HSQLDB-Specific Information:

  Starting with HSQLDB 1.7.2, this value is retrieved through an SQL call to the new `Library.getDatabaseProductVersion` method which allows correct determination of the database product name for both local and remote database instances.

  Specified by:
    `getDatabaseProductVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    database version number
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getDriverName

    public java.lang.String getDriverName()
                                   throws java.sql.SQLException

  Retrieves the name of this JDBC driver.

  Specified by:
    `getDriverName` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC driver name
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getDriverVersion

    public java.lang.String getDriverVersion()
                                      throws java.sql.SQLException

  Retrieves the version number of this JDBC driver as a `String`.

  Specified by:
    `getDriverVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC driver version
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getDriverMajorVersion

    public int getDriverMajorVersion()

  Retrieves this JDBC driver's major version number.

  Specified by:
    `getDriverMajorVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC driver major version

### getDriverMinorVersion

    public int getDriverMinorVersion()

  Retrieves this JDBC driver's minor version number.

  Specified by:
    `getDriverMinorVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC driver minor version number

### usesLocalFiles

    public boolean usesLocalFiles()
                           throws java.sql.SQLException

  Retrieves whether this database stores tables in a local file.

  ### HSQLDB-Specific Information:

  From HSQLDB 1.7.2 it is assumed that this refers to data being stored by the JDBC client. This method always returns false.

  Specified by:
    `usesLocalFiles` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### usesLocalFilePerTable

    public boolean usesLocalFilePerTable()
                                  throws java.sql.SQLException

  Retrieves whether this database uses a file for each table.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not use a file for each table. This method always returns `false`.

  Specified by:
    `usesLocalFilePerTable` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if this database uses a local file for each table; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsMixedCaseIdentifiers

    public boolean supportsMixedCaseIdentifiers()
                                         throws java.sql.SQLException

  Retrieves whether this database treats mixed case unquoted SQL identifiers as case sensitive and as a result stores them in mixed case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `supportsMixedCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### storesUpperCaseIdentifiers

    public boolean storesUpperCaseIdentifiers()
                                       throws java.sql.SQLException

  Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in upper case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `true`.

  Specified by:
    `storesUpperCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### storesLowerCaseIdentifiers

    public boolean storesLowerCaseIdentifiers()
                                       throws java.sql.SQLException

  Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in lower case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesLowerCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### storesMixedCaseIdentifiers

    public boolean storesMixedCaseIdentifiers()
                                       throws java.sql.SQLException

  Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in mixed case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesMixedCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsMixedCaseQuotedIdentifiers

    public boolean supportsMixedCaseQuotedIdentifiers()
                                               throws java.sql.SQLException

  Retrieves whether this database treats mixed case quoted SQL identifiers as case sensitive and as a result stores them in mixed case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `true`.

  Specified by:
    `supportsMixedCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### storesUpperCaseQuotedIdentifiers

    public boolean storesUpperCaseQuotedIdentifiers()
                                             throws java.sql.SQLException

  Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in upper case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesUpperCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### storesLowerCaseQuotedIdentifiers

    public boolean storesLowerCaseQuotedIdentifiers()
                                             throws java.sql.SQLException

  Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in lower case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesLowerCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### storesMixedCaseQuotedIdentifiers

    public boolean storesMixedCaseQuotedIdentifiers()
                                             throws java.sql.SQLException

  Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in mixed case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesMixedCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getIdentifierQuoteString

    public java.lang.String getIdentifierQuoteString()
                                              throws java.sql.SQLException

  Retrieves the string used to quote SQL identifiers. This method returns a space " " if identifier quoting is not supported.

  ### HSQLDB-Specific Information:

  HSQLDB uses the standard SQL identifier quote character (the double quote character); this method always returns ".

  Specified by:
    `getIdentifierQuoteString` in interface `java.sql.DatabaseMetaData`
  Returns:
    the quoting string or a space if quoting is not supported
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getSQLKeywords

    public java.lang.String getSQLKeywords()
                                    throws java.sql.SQLException

  Retrieves a comma-separated list of all of this database's SQL keywords that are NOT also SQL92 keywords.

  ### HSQLDB-Specific Information:

  The list returned contains HSQLDB keywords that are not in the list of reserved words. Some of these are in the list reserved words for SQL 2003 but are not SQL92 keywords.

  Specified by:
    `getSQLKeywords` in interface `java.sql.DatabaseMetaData`
  Returns:
    the list of this database's keywords that are not also SQL92 keywords
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getNumericFunctions

    public java.lang.String getNumericFunctions()
                                         throws java.sql.SQLException

  Retrieves a comma-separated list of math functions available with this database. These are the Open Group CLI math function names used in the JDBC function escape clause.

  Specified by:
    `getNumericFunctions` in interface `java.sql.DatabaseMetaData`
  Returns:
    the list of math functions supported by this database
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getStringFunctions

    public java.lang.String getStringFunctions()
                                        throws java.sql.SQLException

  Retrieves a comma-separated list of string functions available with this database. These are the Open Group CLI string function names used in the JDBC function escape clause.

  Specified by:
    `getStringFunctions` in interface `java.sql.DatabaseMetaData`
  Returns:
    the list of string functions supported by this database
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getSystemFunctions

    public java.lang.String getSystemFunctions()
                                        throws java.sql.SQLException

  Retrieves a comma-separated list of system functions available with this database. These are the Open Group CLI system function names used in the JDBC function escape clause.

  Specified by:
    `getSystemFunctions` in interface `java.sql.DatabaseMetaData`
  Returns:
    a list of system functions supported by this database
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getTimeDateFunctions

    public java.lang.String getTimeDateFunctions()
                                          throws java.sql.SQLException

  Retrieves a comma-separated list of the time and date functions available with this database.

  Specified by:
    `getTimeDateFunctions` in interface `java.sql.DatabaseMetaData`
  Returns:
    the list of time and date functions supported by this database
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getSearchStringEscape

    public java.lang.String getSearchStringEscape()
                                           throws java.sql.SQLException

  Retrieves the string that can be used to escape wildcard characters. This is the string that can be used to escape '_' or '%' in the catalog search parameters that are a pattern (and therefore use one of the wildcard characters).

  The '_' character represents any single character; the '%' character represents any sequence of zero or more characters.

  ### HSQLDB-Specific Information:

  HSQLDB uses the "\" character to escape wildcard characters.

  Specified by:
    `getSearchStringEscape` in interface `java.sql.DatabaseMetaData`
  Returns:
    the string used to escape wildcard characters
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getExtraNameCharacters

    public java.lang.String getExtraNameCharacters()
                                            throws java.sql.SQLException

  Retrieves all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).

  ### HSQLDB-Specific Information:

  HSQLDB does not support using any "extra" characters in unquoted identifier names; this method always returns the empty String.

  Specified by:
    `getExtraNameCharacters` in interface `java.sql.DatabaseMetaData`
  Returns:
    the string containing the extra characters
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsAlterTableWithAddColumn

    public boolean supportsAlterTableWithAddColumn()
                                            throws java.sql.SQLException

  Retrieves whether this database supports `ALTER TABLE` with add column.

  ### HSQLDB-Specific Information:

  From 1.7.0, HSQLDB supports this type of `ALTER TABLE` statement; this method always returns `true`.

  Specified by:
    `supportsAlterTableWithAddColumn` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsAlterTableWithDropColumn

    public boolean supportsAlterTableWithDropColumn()
                                             throws java.sql.SQLException

  Retrieves whether this database supports `ALTER TABLE` with drop column.

  ### HSQLDB-Specific Information:

  From 1.7.0, HSQLDB supports this type of `ALTER TABLE` statement; this method always returns `true`.

  Specified by:
    `supportsAlterTableWithDropColumn` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsColumnAliasing

    public boolean supportsColumnAliasing()
                                   throws java.sql.SQLException

  Retrieves whether this database supports column aliasing.

  If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required.

  ### HSQLDB-Specific Information:

  HSQLDB supports column aliasing; this method always returns `true`.

  Specified by:
    `supportsColumnAliasing` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### nullPlusNonNullIsNull

    public boolean nullPlusNonNullIsNull()
                                  throws java.sql.SQLException

  Retrieves whether this database supports concatenations between `NULL` and non-`NULL` values being `NULL`.

  ### HSQLDB-Specific Information:

  HSQLDB supports this; this method always returns `true`.

  Specified by:
    `nullPlusNonNullIsNull` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsConvert

    public boolean supportsConvert()
                            throws java.sql.SQLException

  Retrieves whether this database supports the `CONVERT` function between SQL types.

  ### HSQLDB-Specific Information:

  HSQLDB supports conversions; this method always returns `true`.

  Specified by:
    `supportsConvert` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsConvert

    public boolean supportsConvert(int fromType,
                                   int toType)
                            throws java.sql.SQLException

  Retrieves whether this database supports the `CONVERT` for two given SQL types.

  ### HSQLDB-Specific Information:

  HSQLDB supports conversion though String intermediates, so everything should be possible, short of number format errors (all Java objects have a toString method); this method always returns `true`.

  Specified by:
    `supportsConvert` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `fromType` - the type to convert from; one of the type codes from the class `java.sql.Types`
    `toType` - the type to convert to; one of the type codes from the class `java.sql.Types`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `Types`

### supportsTableCorrelationNames

    public boolean supportsTableCorrelationNames()
                                          throws java.sql.SQLException

  Retrieves whether this database supports table correlation names.

  ### HSQLDB-Specific Information:

  HSQLDB supports table correlation names; this method always returns `true`.

  Specified by:
    `supportsTableCorrelationNames` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsDifferentTableCorrelationNames

    public boolean supportsDifferentTableCorrelationNames()
                                                   throws java.sql.SQLException

  Retrieves whether, when table correlation names are supported, they are restricted to being different from the names of the tables.

  ### HSQLDB-Specific Information:

  HSQLDB requires that table correlation names are different from the names of the tables; this method always returns `true`.

  Specified by:
    `supportsDifferentTableCorrelationNames` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsExpressionsInOrderBy

    public boolean supportsExpressionsInOrderBy()
                                         throws java.sql.SQLException

  Retrieves whether this database supports expressions in `ORDER BY` lists.

  ### HSQLDB-Specific Information:

  HSQLDB supports expressions in `ORDER BY` lists; this method always returns `true`.

  Specified by:
    `supportsExpressionsInOrderBy` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsOrderByUnrelated

    public boolean supportsOrderByUnrelated()
                                     throws java.sql.SQLException

  Retrieves whether this database supports using a column that is not in the `SELECT` statement in an `ORDER BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports using a column that is not in the `SELECT` statement in an `ORDER BY` clause; this method always returns `true`.

  Specified by:
    `supportsOrderByUnrelated` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsGroupBy

    public boolean supportsGroupBy()
                            throws java.sql.SQLException

  Retrieves whether this database supports some form of `GROUP BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports using the `GROUP BY` clause; this method always returns `true`.

  Specified by:
    `supportsGroupBy` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsGroupByUnrelated

    public boolean supportsGroupByUnrelated()
                                     throws java.sql.SQLException

  Retrieves whether this database supports using a column that is not in the `SELECT` statement in a `GROUP BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports using a column that is not in the `SELECT` statement in a `GROUP BY` clause; this method always returns `true`.

  Specified by:
    `supportsGroupByUnrelated` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsGroupByBeyondSelect

    public boolean supportsGroupByBeyondSelect()
                                        throws java.sql.SQLException

  Retrieves whether this database supports using columns not included in the `SELECT` statement in a `GROUP BY` clause provided that all of the columns in the `SELECT` statement are included in the `GROUP BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports using columns not included in the `SELECT` statement in a `GROUP BY` clause provided that all of the columns in the `SELECT` statement are included in the `GROUP BY` clause; this method always returns `true`.

  Specified by:
    `supportsGroupByBeyondSelect` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsLikeEscapeClause

    public boolean supportsLikeEscapeClause()
                                     throws java.sql.SQLException

  Retrieves whether this database supports specifying a `LIKE` escape clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports specifying a `LIKE` escape clause; this method always returns `true`.

  Specified by:
    `supportsLikeEscapeClause` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsMultipleResultSets

    public boolean supportsMultipleResultSets()
                                       throws java.sql.SQLException

  Retrieves whether this database supports getting multiple `ResultSet` objects from a single call to the method `execute`.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support getting multiple `ResultSet` objects from a single call to the method `execute`; this method always returns `false`.

  This behaviour may change in a future release.

  Specified by:
    `supportsMultipleResultSets` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsMultipleTransactions

    public boolean supportsMultipleTransactions()
                                         throws java.sql.SQLException

  Retrieves whether this database allows having multiple transactions open at once (on different connections).

  ### HSQLDB-Specific Information:

  HSQLDB allows having multiple transactions open at once (on different connections); this method always returns `true`.

  Specified by:
    `supportsMultipleTransactions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsNonNullableColumns

    public boolean supportsNonNullableColumns()
                                       throws java.sql.SQLException

  Retrieves whether columns in this database may be defined as non-nullable.

  ### HSQLDB-Specific Information:

  HSQLDB supports the specification of non-nullable columns; this method always returns `true`.

  Specified by:
    `supportsNonNullableColumns` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsMinimumSQLGrammar

    public boolean supportsMinimumSQLGrammar()
                                      throws java.sql.SQLException

  Retrieves whether this database supports the ODBC Minimum SQL grammar.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support the ODBC Minimum SQL grammar; this method always returns `false`.

  Specified by:
    `supportsMinimumSQLGrammar` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsCoreSQLGrammar

    public boolean supportsCoreSQLGrammar()
                                   throws java.sql.SQLException

  Retrieves whether this database supports the ODBC Core SQL grammar.

  ### HSQLDB-Specific Information:

  From 1.7.2 this method always returns `true`.

  Specified by:
    `supportsCoreSQLGrammar` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsExtendedSQLGrammar

    public boolean supportsExtendedSQLGrammar()
                                       throws java.sql.SQLException

  Retrieves whether this database supports the ODBC Extended SQL grammar.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support the ODBC Extended SQL grammar; this method always returns `false`.

  Specified by:
    `supportsExtendedSQLGrammar` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsANSI92EntryLevelSQL

    public boolean supportsANSI92EntryLevelSQL()
                                        throws java.sql.SQLException

  Retrieves whether this database supports the ANSI92 entry level SQL grammar.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support the ANSI92 entry level SQL grammar; this method always returns `false`.

  Specified by:
    `supportsANSI92EntryLevelSQL` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsANSI92IntermediateSQL

    public boolean supportsANSI92IntermediateSQL()
                                          throws java.sql.SQLException

  Retrieves whether this database supports the ANSI92 intermediate SQL grammar supported.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support the ANSI92 intermediate SQL grammar; this method always returns `false`.

  Specified by:
    `supportsANSI92IntermediateSQL` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsANSI92FullSQL

    public boolean supportsANSI92FullSQL()
                                  throws java.sql.SQLException

  Retrieves whether this database supports the ANSI92 full SQL grammar supported.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support the ANSI92 full SQL grammar; this method always returns `false`.

  Specified by:
    `supportsANSI92FullSQL` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsIntegrityEnhancementFacility

    public boolean supportsIntegrityEnhancementFacility()
                                                 throws java.sql.SQLException

  Retrieves whether this database supports the SQL Integrity Enhancement Facility.

  ### HSQLDB-Specific Information:

  From 1.7.2, this method always returns `true`.

  Specified by:
    `supportsIntegrityEnhancementFacility` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsOuterJoins

    public boolean supportsOuterJoins()
                               throws java.sql.SQLException

  Retrieves whether this database supports some form of outer join.

  ### HSQLDB-Specific Information:

  HSQLDB supports outer joins; this method always returns `true`.

  Specified by:
    `supportsOuterJoins` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsFullOuterJoins

    public boolean supportsFullOuterJoins()
                                   throws java.sql.SQLException

  Retrieves whether this database supports full nested outer joins.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support full nested outer joins; this method always returns `false`.

  This behaviour may change in a future release.

  Specified by:
    `supportsFullOuterJoins` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsLimitedOuterJoins

    public boolean supportsLimitedOuterJoins()
                                      throws java.sql.SQLException

  Retrieves whether this database provides limited support for outer joins. (This will be `true` if the method `supportsFullOuterJoins` returns `true`).

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB support the LEFT OUTER join syntax; this method always returns `true`.

  Specified by:
    `supportsLimitedOuterJoins` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getSchemaTerm

    public java.lang.String getSchemaTerm()
                                   throws java.sql.SQLException

  Retrieves the database vendor's preferred term for "schema".

  ### HSQLDB-Specific Information:

  Starting with 1.8.0, HSQLDB provides support for schemas.

  Specified by:
    `getSchemaTerm` in interface `java.sql.DatabaseMetaData`
  Returns:
    the vendor term for "schema"
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getProcedureTerm

    public java.lang.String getProcedureTerm()
                                      throws java.sql.SQLException

  Retrieves the database vendor's preferred term for "procedure".

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support declaration of functions or procedures directly in SQL but instead relies on the HSQLDB-specific CLASS grant mechanism to make public static Java methods available as SQL routines; this method always returns an empty `String`.

  Specified by:
    `getProcedureTerm` in interface `java.sql.DatabaseMetaData`
  Returns:
    the vendor term for "procedure"
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getCatalogTerm

    public java.lang.String getCatalogTerm()
                                    throws java.sql.SQLException

  Retrieves the database vendor's preferred term for "catalog".

  ### HSQLDB-Specific Information:

  Including 1.7.2, HSQLDB does not support catalogs in DDL or DML; this method always returns the empty String.

  Specified by:
    `getCatalogTerm` in interface `java.sql.DatabaseMetaData`
  Returns:
    the vendor term for "catalog"
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### isCatalogAtStart

    public boolean isCatalogAtStart()
                             throws java.sql.SQLException

  Retrieves whether a catalog appears at the start of a fully qualified table name. If not, the catalog appears at the end.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support catalogs in DDL or DML; this method always returns `false`.

  Specified by:
    `isCatalogAtStart` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if the catalog name appears at the beginning of a fully qualified table name; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getCatalogSeparator

    public java.lang.String getCatalogSeparator()
                                         throws java.sql.SQLException

  Retrieves the `String` that this database uses as the separator between a catalog and table name.

  ### HSQLDB-Specific Information:

  Including 1.7.2, HSQLDB does not support catalogs in DDL or DML; this method always returns an empty `String`.

  Specified by:
    `getCatalogSeparator` in interface `java.sql.DatabaseMetaData`
  Returns:
    the separator string
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsSchemasInDataManipulation

    public boolean supportsSchemasInDataManipulation()
                                              throws java.sql.SQLException

  Retrieves whether a schema name can be used in a data manipulation statement.

  ### HSQLDB-Specific Information:

  In 1.8.0, HSQLDB supports schemas in table names but not in column names; this method always returns `false`.

  Specified by:
    `supportsSchemasInDataManipulation` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsSchemasInProcedureCalls

    public boolean supportsSchemasInProcedureCalls()
                                            throws java.sql.SQLException

  Retrieves whether a schema name can be used in a procedure call statement.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support schema-qualified procedure identifiers; this method always returns `false`.

  Specified by:
    `supportsSchemasInProcedureCalls` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsSchemasInTableDefinitions

    public boolean supportsSchemasInTableDefinitions()
                                              throws java.sql.SQLException

  Retrieves whether a schema name can be used in a table definition statement.

  ### HSQLDB-Specific Information:

  In 1.8.0, HSQLDB supports schemas; By default, this method returns `true`.

  Specified by:
    `supportsSchemasInTableDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsSchemasInIndexDefinitions

    public boolean supportsSchemasInIndexDefinitions()
                                              throws java.sql.SQLException

  Retrieves whether a schema name can be used in an index definition statement.

  ### HSQLDB-Specific Information:

  In 1.8.0, HSQLDB supports schemas; By default, this method returns `true`.

  Specified by:
    `supportsSchemasInIndexDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsSchemasInPrivilegeDefinitions

    public boolean supportsSchemasInPrivilegeDefinitions()
                                                  throws java.sql.SQLException

  Retrieves whether a schema name can be used in a privilege definition statement.

  ### HSQLDB-Specific Information:

  In 1.8.0, HSQLDB supports schemas; By default, this method returns `true`.

  Specified by:
    `supportsSchemasInPrivilegeDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsCatalogsInDataManipulation

    public boolean supportsCatalogsInDataManipulation()
                                               throws java.sql.SQLException

  Retrieves whether a catalog name can be used in a data manipulation statement.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support catalog-qualified; data manipulation; this method always returns `false`.

  Specified by:
    `supportsCatalogsInDataManipulation` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsCatalogsInProcedureCalls

    public boolean supportsCatalogsInProcedureCalls()
                                             throws java.sql.SQLException

  Retrieves whether a catalog name can be used in a procedure call statement.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support catalog-qualified procedure calls; this method always returns `false`.

  Specified by:
    `supportsCatalogsInProcedureCalls` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsCatalogsInTableDefinitions

    public boolean supportsCatalogsInTableDefinitions()
                                               throws java.sql.SQLException

  Retrieves whether a catalog name can be used in a table definition statement.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support catalog-qualified table definitions; this method always returns `false`.

  Specified by:
    `supportsCatalogsInTableDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsCatalogsInIndexDefinitions

    public boolean supportsCatalogsInIndexDefinitions()
                                               throws java.sql.SQLException

  Retrieves whether a catalog name can be used in an index definition statement.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support catalog-qualified index definitions; this method always returns `false`.

  Specified by:
    `supportsCatalogsInIndexDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsCatalogsInPrivilegeDefinitions

    public boolean supportsCatalogsInPrivilegeDefinitions()
                                                   throws java.sql.SQLException

  Retrieves whether a catalog name can be used in a privilege definition statement.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support catalog-qualified privilege definitions; this method always returns `false`.

  Specified by:
    `supportsCatalogsInPrivilegeDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsPositionedDelete

    public boolean supportsPositionedDelete()
                                     throws java.sql.SQLException

  Retrieves whether this database supports positioned `DELETE` statements.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `supportsPositionedDelete` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsPositionedUpdate

    public boolean supportsPositionedUpdate()
                                     throws java.sql.SQLException

  Retrieves whether this database supports positioned `UPDATE` statements.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `supportsPositionedUpdate` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsSelectForUpdate

    public boolean supportsSelectForUpdate()
                                    throws java.sql.SQLException

  Retrieves whether this database supports `SELECT FOR UPDATE` statements.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support explicit locking; this method always returns `false`.

  Specified by:
    `supportsSelectForUpdate` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsStoredProcedures

    public boolean supportsStoredProcedures()
                                     throws java.sql.SQLException

  Retrieves whether this database supports stored procedure calls that use the stored procedure escape syntax.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB supports calling public static Java methods in the context of SQL Stored Procedures; this method always returns `true`.

  Specified by:
    `supportsStoredProcedures` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `jdbcPreparedStatement`, `jdbcConnection.prepareCall(java.lang.String)`

### supportsSubqueriesInComparisons

    public boolean supportsSubqueriesInComparisons()
                                            throws java.sql.SQLException

  Retrieves whether this database supports subqueries in comparison expressions.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported subqueries in comparison expressions; this method always returns `true`.

  Specified by:
    `supportsSubqueriesInComparisons` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsSubqueriesInExists

    public boolean supportsSubqueriesInExists()
                                       throws java.sql.SQLException

  Retrieves whether this database supports subqueries in `EXISTS` expressions.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported subqueries in `EXISTS` expressions; this method always returns `true`.

  Specified by:
    `supportsSubqueriesInExists` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsSubqueriesInIns

    public boolean supportsSubqueriesInIns()
                                    throws java.sql.SQLException

  JDBC4 correction: Retrieves whether this database supports subqueries in `IN` expressions.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported subqueries in `IN` statements; this method always returns `true`.

  Specified by:
    `supportsSubqueriesInIns` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsSubqueriesInQuantifieds

    public boolean supportsSubqueriesInQuantifieds()
                                            throws java.sql.SQLException

  Retrieves whether this database supports subqueries in quantified expressions.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported subqueries in quantified expressions; this method always returns `true`.

  Specified by:
    `supportsSubqueriesInQuantifieds` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsCorrelatedSubqueries

    public boolean supportsCorrelatedSubqueries()
                                         throws java.sql.SQLException

  Retrieves whether this database supports correlated subqueries.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported correlated subqueries; this method always returns `true`.

  Specified by:
    `supportsCorrelatedSubqueries` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsUnion

    public boolean supportsUnion()
                          throws java.sql.SQLException

  Retrieves whether this database supports SQL `UNION`.

  ### HSQLDB-Specific Information:

  HSQLDB supports SQL `UNION`; this method always returns `true`.

  Specified by:
    `supportsUnion` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsUnionAll

    public boolean supportsUnionAll()
                             throws java.sql.SQLException

  Retrieves whether this database supports SQL `UNION ALL`.

  ### HSQLDB-Specific Information:

  HSQLDB supports SQL `UNION ALL`; this method always returns `true`.

  Specified by:
    `supportsUnionAll` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsOpenCursorsAcrossCommit

    public boolean supportsOpenCursorsAcrossCommit()
                                            throws java.sql.SQLException

  Retrieves whether this database supports keeping cursors open across commits.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support keeping cursors open across commits; this method always returns `false`.

  Specified by:
    `supportsOpenCursorsAcrossCommit` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsOpenCursorsAcrossRollback

    public boolean supportsOpenCursorsAcrossRollback()
                                              throws java.sql.SQLException

  Retrieves whether this database supports keeping cursors open across rollbacks.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support keeping cursors open across rollbacks; this method always returns `false`.

  Specified by:
    `supportsOpenCursorsAcrossRollback` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsOpenStatementsAcrossCommit

    public boolean supportsOpenStatementsAcrossCommit()
                                               throws java.sql.SQLException

  Retrieves whether this database supports keeping statements open across commits.

  ### HSQLDB-Specific Information:

  HSQLDB supports keeping statements open across commits; this method always returns `true`.

  Specified by:
    `supportsOpenStatementsAcrossCommit` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsOpenStatementsAcrossRollback

    public boolean supportsOpenStatementsAcrossRollback()
                                                 throws java.sql.SQLException

  Retrieves whether this database supports keeping statements open across rollbacks.

  ### HSQLDB-Specific Information:

  HSQLDB supports keeping statements open across commits; this method always returns `true`.

  Specified by:
    `supportsOpenStatementsAcrossRollback` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxBinaryLiteralLength

    public int getMaxBinaryLiteralLength()
                                  throws java.sql.SQLException

  Retrieves the maximum number of hex characters this database allows in an inline binary literal.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a java.lang.String (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxBinaryLiteralLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max the maximum length (in hex characters) for a binary literal; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxCharLiteralLength

    public int getMaxCharLiteralLength()
                                throws java.sql.SQLException

  Retrieves the maximum number of characters this database allows for a character literal.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a java.lang.String (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxCharLiteralLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for a character literal; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxColumnNameLength

    public int getMaxColumnNameLength()
                               throws java.sql.SQLException

  Retrieves the maximum number of characters this database allows for a column name.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a java.lang.String (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxColumnNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for a column name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxColumnsInGroupBy

    public int getMaxColumnsInGroupBy()
                               throws java.sql.SQLException

  Retrieves the maximum number of columns this database allows in a `GROUP BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a Java array (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxColumnsInGroupBy` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxColumnsInIndex

    public int getMaxColumnsInIndex()
                             throws java.sql.SQLException

  Retrieves the maximum number of columns this database allows in an index.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a Java array (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxColumnsInIndex` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxColumnsInOrderBy

    public int getMaxColumnsInOrderBy()
                               throws java.sql.SQLException

  Retrieves the maximum number of columns this database allows in an `ORDER BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a Java array (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxColumnsInOrderBy` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxColumnsInSelect

    public int getMaxColumnsInSelect()
                              throws java.sql.SQLException

  Retrieves the maximum number of columns this database allows in a `SELECT` list.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a Java array (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxColumnsInSelect` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxColumnsInTable

    public int getMaxColumnsInTable()
                             throws java.sql.SQLException

  Retrieves the maximum number of columns this database allows in a table.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a Java array (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxColumnsInTable` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxConnections

    public int getMaxConnections()
                          throws java.sql.SQLException

  Retrieves the maximum number of concurrent connections to this database that are possible.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a Java array (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxConnections` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of active connections possible at one time; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxCursorNameLength

    public int getMaxCursorNameLength()
                               throws java.sql.SQLException

  Retrieves the maximum number of characters that this database allows in a cursor name.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a java.lang.String (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxCursorNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of characters allowed in a cursor name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxIndexLength

    public int getMaxIndexLength()
                          throws java.sql.SQLException

  Retrieves the maximum number of bytes this database allows for an index, including all of the parts of the index.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit; this method always returns `0`.

  Specified by:
    `getMaxIndexLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of bytes allowed; this limit includes the composite of all the constituent parts of the index; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxSchemaNameLength

    public int getMaxSchemaNameLength()
                               throws java.sql.SQLException

  Retrieves the maximum number of characters that this database allows in a schema name.

  ### HSQLDB-Specific Information:

  1.8.0 supports schema names with no known limit imposed, so this method always returns `0`.

  Specified by:
    `getMaxSchemaNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of characters allowed in a schema name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxProcedureNameLength

    public int getMaxProcedureNameLength()
                                  throws java.sql.SQLException

  Retrieves the maximum number of characters that this database allows in a procedure name.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a java.lang.String (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxProcedureNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of characters allowed in a procedure name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxCatalogNameLength

    public int getMaxCatalogNameLength()
                                throws java.sql.SQLException

  Retrieves the maximum number of characters that this database allows in a catalog name.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support catalogs in DDL or DML; this method always returns `0`.

  Specified by:
    `getMaxCatalogNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of characters allowed in a catalog name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxRowSize

    public int getMaxRowSize()
                      throws java.sql.SQLException

  Retrieves the maximum number of bytes this database allows in a single row.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit; this method always returns `0`.

  Specified by:
    `getMaxRowSize` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of bytes allowed for a row; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### doesMaxRowSizeIncludeBlobs

    public boolean doesMaxRowSizeIncludeBlobs()
                                       throws java.sql.SQLException

  Retrieves whether the return value for the method `getMaxRowSize` includes the SQL data types `LONGVARCHAR` and `LONGVARBINARY`.

  ### HSQLDB-Specific Indormation:

  Including 1.7.2, `getMaxRowSize()` always returns 0, indicating that the maximum row size is unknown or has no limit. This applies to the above types as well; this method always returns `true`.

  Specified by:
    `doesMaxRowSizeIncludeBlobs` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxStatementLength

    public int getMaxStatementLength()
                              throws java.sql.SQLException

  Retrieves the maximum number of characters this database allows in an SQL statement.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a java.lang.String (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxStatementLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for an SQL statement; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxStatements

    public int getMaxStatements()
                         throws java.sql.SQLException

  Retrieves the maximum number of active statements to this database that can be open at the same time.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit; this method always returns `0`.

  Specified by:
    `getMaxStatements` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of statements that can be open at one time; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxTableNameLength

    public int getMaxTableNameLength()
                              throws java.sql.SQLException

  Retrieves the maximum number of characters this database allows in a table name.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a java.lang.String (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxTableNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for a table name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxTablesInSelect

    public int getMaxTablesInSelect()
                             throws java.sql.SQLException

  Retrieves the maximum number of tables this database allows in a `SELECT` statement.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a Java array (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxTablesInSelect` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of tables allowed in a `SELECT` statement; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMaxUserNameLength

    public int getMaxUserNameLength()
                             throws java.sql.SQLException

  Retrieves the maximum number of characters this database allows in a user name.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The hard limit is the maximum length of a java.lang.String (java.lang.Integer.MAX_VALUE); this method always returns `0`.

  Specified by:
    `getMaxUserNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for a user name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getDefaultTransactionIsolation

    public int getDefaultTransactionIsolation()
                                       throws java.sql.SQLException

  Retrieves this database's default transaction isolation level. The possible values are defined in `java.sql.Connection`.

  ### HSQLDB-Specific Information

  Including 1.7.2, HSQLDB supports only TRANSACTION_READ_UNCOMMITED and always returns this value here.

  Specified by:
    `getDefaultTransactionIsolation` in interface `java.sql.DatabaseMetaData`
  Returns:
    the default isolation level
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `jdbcConnection`

### supportsTransactions

    public boolean supportsTransactions()
                                 throws java.sql.SQLException

  Retrieves whether this database supports transactions. If not, invoking the method `commit` is a noop, and the isolation level is `TRANSACTION_NONE`.

  ### HSQLDB-Specific Information:

  HSQLDB supports transactions; this method always returns `true`.

  Specified by:
    `supportsTransactions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if transactions are supported; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsTransactionIsolationLevel

    public boolean supportsTransactionIsolationLevel(int level)
                                              throws java.sql.SQLException

  Retrieves whether this database supports the given transaction isolation level.

  ### HSQLDB-Specific Information

  HSQLDB supports `TRANSACTION_READ_UNCOMMITED` in all cases and the rest of the isolation levels where there is only one connection to the database.

  Specified by:
    `supportsTransactionIsolationLevel` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `level` - one of the transaction isolation levels defined in `java.sql.Connection`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `jdbcConnection`

### supportsDataDefinitionAndDataManipulationTransactions

    public boolean supportsDataDefinitionAndDataManipulationTransactions()
                                                                  throws java.sql.SQLException

  Retrieves whether this database supports both data definition and data manipulation statements within a transaction.

  ### HSQLDB-Specific Information:

  HSQLDB does not support a mix of both data definition and data manipulation statements within a transaction. DDL commits the current transaction before proceding; this method always returns `false`.

  Specified by:
    `supportsDataDefinitionAndDataManipulationTransactions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsDataManipulationTransactionsOnly

    public boolean supportsDataManipulationTransactionsOnly()
                                                     throws java.sql.SQLException

  Retrieves whether this database supports only data manipulation statements within a transaction.

  ### HSQLDB-Specific Information:

  HSQLDB supports only data manipulation statements within a transaction. DDL commits the current transaction before proceeding, while DML does not; this method always returns `true`.

  Specified by:
    `supportsDataManipulationTransactionsOnly` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### dataDefinitionCausesTransactionCommit

    public boolean dataDefinitionCausesTransactionCommit()
                                                  throws java.sql.SQLException

  Retrieves whether a data definition statement within a transaction forces the transaction to commit.

  ### HSQLDB-Specific Information:

  Including 1.7.2, a data definition statement within a transaction forces the transaction to commit; this method always returns `true`.

  Specified by:
    `dataDefinitionCausesTransactionCommit` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### dataDefinitionIgnoredInTransactions

    public boolean dataDefinitionIgnoredInTransactions()
                                                throws java.sql.SQLException

  Retrieves whether this database ignores a data definition statement within a transaction.

  ### HSQLDB-Specific Information:

  Including 1.7.2, a data definition statement is not ignored within a transaction. Rather, a data definition statement within a transaction forces the transaction to commit; this method always returns `false`.

  Specified by:
    `dataDefinitionIgnoredInTransactions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getProcedures

    public java.sql.ResultSet getProcedures(java.lang.String catalog,
                                            java.lang.String schemaPattern,
                                            java.lang.String procedureNamePattern)
                                     throws java.sql.SQLException

  Retrieves a description of the stored procedures available in the given catalog.

  Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by `PROCEDURE_SCHEM` and `PROCEDURE_NAME`.

  Each procedure description has the the following columns:

  1. PROCEDURE_CAT String => procedure catalog (may be `null`)
  2. PROCEDURE_SCHEM String => procedure schema (may be `null`)
  3. PROCEDURE_NAME String => procedure name
  4. reserved for future use
  5. reserved for future use
  6. reserved for future use
  7. REMARKS String => explanatory comment on the procedure
  8. PROCEDURE_TYPE short => kind of procedure:
     - procedureResultUnknown - May return a result
     - procedureNoResult - Does not return a result
     - procedureReturnsResult - Returns a result

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getProcedures` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `procedureNamePattern` - a procedure name pattern; must match the procedure name as it is stored in the database
  Returns:
    `ResultSet` - each row is a procedure description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getProcedureColumns

    public java.sql.ResultSet getProcedureColumns(java.lang.String catalog,
                                                  java.lang.String schemaPattern,
                                                  java.lang.String procedureNamePattern,
                                                  java.lang.String columnNamePattern)
                                           throws java.sql.SQLException

  Retrieves a description of the given catalog's stored procedure parameter and result columns.

  Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by PROCEDURE_SCHEM and PROCEDURE_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

  Each row in the `ResultSet` is a parameter description or column description with the following fields:

  1. PROCEDURE_CAT String => procedure catalog (may be `null`)
  2. PROCEDURE_SCHEM String => procedure schema (may be `null`)
  3. PROCEDURE_NAME String => procedure name
  4. COLUMN_NAME String => column/parameter name
  5. COLUMN_TYPE Short => kind of column/parameter:
     - procedureColumnUnknown - nobody knows
     - procedureColumnIn - IN parameter
     - procedureColumnInOut - INOUT parameter
     - procedureColumnOut - OUT parameter
     - procedureColumnReturn - procedure return value
     - procedureColumnResult - result column in `ResultSet`
  6. DATA_TYPE short => SQL type from java.sql.Types
  7. TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
  8. PRECISION int => precision
  9. LENGTH int => length in bytes of data
  10. SCALE short => scale
  11. RADIX short => radix
  12. NULLABLE short => can it contain NULL.
      - procedureNoNulls - does not allow NULL values
      - procedureNullable - allows NULL values
      - procedureNullableUnknown - nullability unknown
  13. REMARKS String => comment describing parameter/column

  Note: Some databases may not return the column descriptions for a procedure. Additional columns beyond REMARKS can be defined by the database.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getProcedureColumns` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `procedureNamePattern` - a procedure name pattern; must match the procedure name as it is stored in the database
    `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
  Returns:
    `ResultSet` - each row describes a stored procedure parameter or column
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTables

    public java.sql.ResultSet getTables(java.lang.String catalog,
                                        java.lang.String schemaPattern,
                                        java.lang.String tableNamePattern,
                                        java.lang.String[] types)
                                 throws java.sql.SQLException

  Retrieves a description of the tables available in the given catalog. Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.

  Each table description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
  5. REMARKS String => explanatory comment on the table
  6. TYPE_CAT String => the types catalog (may be `null`)
  7. TYPE_SCHEM String => the types schema (may be `null`)
  8. TYPE_NAME String => type name (may be `null`)
  9. SELF_REFERENCING_COL_NAME String => name of the designated "identifier" column of a typed table (may be `null`)
  10. REF_GENERATION String => specifies how values in SELF_REFERENCING_COL_NAME are created. Values are "SYSTEM", "USER", "DERIVED". (may be `null`)

  Note: Some databases may not return information for all tables.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.0, HSQLDB returns extra information on TEXT tables in the REMARKS column.

  Since 1.7.0, HSQLDB includes the new JDBC3 columns TYPE_CAT, TYPE_SCHEM, TYPE_NAME and SELF_REFERENCING_COL_NAME in anticipation of JDBC3 compliant tools.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getTables` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
    `types` - a list of table types to include; `null` returns all types
  Returns:
    `ResultSet` - each row is a table description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getSchemas

    public java.sql.ResultSet getSchemas()
                                  throws java.sql.SQLException

  Retrieves the schema names available in this database. The results are ordered by schema name.

  The schema column is:

  1. TABLE_SCHEM String => schema name
  2. TABLE_CATALOG String => catalog name (may be `null`)

  ### HSQLDB-Specific Information:

  In 1.8.0, the list of schemas is returned.

  Specified by:
    `getSchemas` in interface `java.sql.DatabaseMetaData`
  Returns:
    a `ResultSet` object in which each row is a schema decription
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getCatalogs

    public java.sql.ResultSet getCatalogs()
                                   throws java.sql.SQLException

  Retrieves the catalog names available in this database. The results are ordered by catalog name.

  The catalog column is:

  1. TABLE_CAT String => catalog name

  ### HSQLDB-Specific Information:

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getCatalogs` in interface `java.sql.DatabaseMetaData`
  Returns:
    a `ResultSet` object in which each row has a single `String` column that is a catalog name
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getTableTypes

    public java.sql.ResultSet getTableTypes()
                                     throws java.sql.SQLException

  Retrieves the table types available in this database. The results are ordered by table type.

  The table type is:

  1. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".

  ### HSQLDB-Specific Information:

  Since 1.7.1, HSQLDB reports: "TABLE", "VIEW" and "GLOBAL TEMPORARY" types. Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getTableTypes` in interface `java.sql.DatabaseMetaData`
  Returns:
    a `ResultSet` object in which each row has a single `String` column that is a table type
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getColumns

    public java.sql.ResultSet getColumns(java.lang.String catalog,
                                         java.lang.String schemaPattern,
                                         java.lang.String tableNamePattern,
                                         java.lang.String columnNamePattern)
                                  throws java.sql.SQLException

  Retrieves a description of table columns available in the specified catalog.

  Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by `TABLE_SCHEM`, `TABLE_NAME`, and `ORDINAL_POSITION`.

  Each column description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. DATA_TYPE short => SQL type from java.sql.Types
  6. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  7. COLUMN_SIZE int => column size. For char or date types this is the maximum number of characters, for numeric or decimal types this is precision.
  8. BUFFER_LENGTH is not used.
  9. DECIMAL_DIGITS int => the number of fractional digits
  10. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
  11. NULLABLE int => is NULL allowed.
      - columnNoNulls - might not allow `NULL` values
      - columnNullable - definitely allows `NULL` values
      - columnNullableUnknown - nullability unknown
  12. REMARKS String => comment describing column (may be `null`)
  13. COLUMN_DEF String => default value (may be `null`)
  14. SQL_DATA_TYPE int => unused
  15. SQL_DATETIME_SUB int => unused
  16. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
  17. ORDINAL_POSITION int => index of column in table (starting at 1)
  18. IS_NULLABLE String => "NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means nobody knows.
  19. SCOPE_CATLOG String => catalog of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
  20. SCOPE_SCHEMA String => schema of table that is the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
  21. SCOPE_TABLE String => table name that this the scope of a reference attribure (`null` if the DATA_TYPE isn't REF)
  22. SOURCE_DATA_TYPE short => source type of a distinct type or user-generated Ref type, SQL type from java.sql.Types (`null` if DATA_TYPE isn't DISTINCT or user-generated REF)

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.0, HSQLDB includes the new JDBC 3 columns SCOPE_CATLOG, SCOPE_SCHEMA, SCOPE_TABLE and SOURCE_DATA_TYPE in anticipation of JDBC 3 compliant tools. However, these columns are never filled in; the engine does not support the related features.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getColumns` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
    `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getColumnPrivileges

    public java.sql.ResultSet getColumnPrivileges(java.lang.String catalog,
                                                  java.lang.String schema,
                                                  java.lang.String table,
                                                  java.lang.String columnNamePattern)
                                           throws java.sql.SQLException

  Retrieves a description of the access rights for a table's columns.

  Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. GRANTOR => grantor of access (may be `null`)
  6. GRANTEE String => grantee of access
  7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; `null` if unknown

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getColumnPrivileges` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
    `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
  Returns:
    `ResultSet` - each row is a column privilege description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTablePrivileges

    public java.sql.ResultSet getTablePrivileges(java.lang.String catalog,
                                                 java.lang.String schemaPattern,
                                                 java.lang.String tableNamePattern)
                                          throws java.sql.SQLException

  Retrieves a description of the access rights for each table available in a catalog. Note that a table privilege applies to one or more columns in the table. It would be wrong to assume that this privilege applies to all columns (this may be true for some systems but is not true for all.)

  Only privileges matching the schema and table name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME, and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. GRANTOR => grantor of access (may be `null`)
  5. GRANTEE String => grantee of access
  6. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  7. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; `null` if unknown

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getTablePrivileges` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
  Returns:
    `ResultSet` - each row is a table privilege description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getBestRowIdentifier

    public java.sql.ResultSet getBestRowIdentifier(java.lang.String catalog,
                                                   java.lang.String schema,
                                                   java.lang.String table,
                                                   int scope,
                                                   boolean nullable)
                                            throws java.sql.SQLException

  Retrieves a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

  Each column description has the following columns:

  1. SCOPE short => actual scope of result
     - bestRowTemporary - very temporary, while using row
     - bestRowTransaction - valid for remainder of current transaction
     - bestRowSession - valid for remainder of current session
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => not used
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - bestRowUnknown - may or may not be pseudo column
     - bestRowNotPseudo - is NOT a pseudo column
     - bestRowPseudo - is a pseudo column

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  If the name of a column is defined in the database without double quotes, an all-uppercase name must be specified when calling this method. Otherwise, the name must be specified in the exact case of the column definition in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getBestRowIdentifier` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
    `scope` - the scope of interest; use same values as SCOPE
    `nullable` - include columns that are nullable.
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getVersionColumns

    public java.sql.ResultSet getVersionColumns(java.lang.String catalog,
                                                java.lang.String schema,
                                                java.lang.String table)
                                         throws java.sql.SQLException

  Retrieves a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

  Each column description has the following columns:

  1. SCOPE short => is not used
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from `java.sql.Types`
  4. TYPE_NAME String => Data source-dependent type name
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => length of column value in bytes
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => whether this is pseudo column like an Oracle ROWID
     - versionColumnUnknown - may or may not be pseudo column
     - versionColumnNotPseudo - is NOT a pseudo column
     - versionColumnPseudo - is a pseudo column

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getVersionColumns` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
  Returns:
    a `ResultSet` object in which each row is a column description
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getPrimaryKeys

    public java.sql.ResultSet getPrimaryKeys(java.lang.String catalog,
                                             java.lang.String schema,
                                             java.lang.String table)
                                      throws java.sql.SQLException

  Retrieves a description of the given table's primary key columns. They are ordered by COLUMN_NAME.

  Each primary key column description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. KEY_SEQ short => sequence number within primary key
  6. PK_NAME String => primary key name (may be `null`)

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getPrimaryKeys` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
  Returns:
    `ResultSet` - each row is a primary key column description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### getImportedKeys

    public java.sql.ResultSet getImportedKeys(java.lang.String catalog,
                                              java.lang.String schema,
                                              java.lang.String table)
                                       throws java.sql.SQLException

  Retrieves a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

  Each primary key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog being imported (may be `null`)
  2. PKTABLE_SCHEM String => primary key table schema being imported (may be `null`)
  3. PKTABLE_NAME String => primary key table name being imported
  4. PKCOLUMN_NAME String => primary key column name being imported
  5. FKTABLE_CAT String => foreign key table catalog (may be `null`)
  6. FKTABLE_SCHEM String => foreign key table schema (may be `null`)
  7. FKTABLE_NAME String => foreign key table name
  8. FKCOLUMN_NAME String => foreign key column name
  9. KEY_SEQ short => sequence number within a foreign key
  10. UPDATE_RULE short => What happens to a foreign key when the primary key is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to `NULL` if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be `null`)
  13. PK_NAME String => primary key name (may be `null`)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getImportedKeys` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
  Returns:
    `ResultSet` - each row is a primary key column description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getExportedKeys(java.lang.String, java.lang.String, java.lang.String)`, `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### getExportedKeys

    public java.sql.ResultSet getExportedKeys(java.lang.String catalog,
                                              java.lang.String schema,
                                              java.lang.String table)
                                       throws java.sql.SQLException

  Retrieves a description of the foreign key columns that reference the given table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be `null`)
  2. PKTABLE_SCHEM String => primary key table schema (may be `null`)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be `null`) being exported (may be `null`)
  6. FKTABLE_SCHEM String => foreign key table schema (may be `null`) being exported (may be `null`)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to `NULL` if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to `NULL` if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be `null`)
  13. PK_NAME String => primary key name (may be `null`)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getExportedKeys` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in this database
  Returns:
    a `ResultSet` object in which each row is a foreign key column description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`, `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### getCrossReference

    public java.sql.ResultSet getCrossReference(java.lang.String primaryCatalog,
                                                java.lang.String primarySchema,
                                                java.lang.String primaryTable,
                                                java.lang.String foreignCatalog,
                                                java.lang.String foreignSchema,
                                                java.lang.String foreignTable)
                                         throws java.sql.SQLException

  Retrieves a description of the foreign key columns in the given foreign key table that reference the primary key columns of the given primary key table (describe how one table imports another's key). This should normally return a single foreign key/primary key pair because most tables import a foreign key from a table only once. They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be `null`)
  2. PKTABLE_SCHEM String => primary key table schema (may be `null`)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be `null`) being exported (may be `null`)
  6. FKTABLE_SCHEM String => foreign key table schema (may be `null`) being exported (may be `null`)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to `NULL` if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to `NULL` if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be `null`)
  13. PK_NAME String => primary key name (may be `null`)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getCrossReference` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `primaryCatalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `primarySchema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means drop schema name from the selection criteria
    `primaryTable` - the name of the table that exports the key; must match the table name as it is stored in the database
    `foreignCatalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `foreignSchema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means drop schema name from the selection criteria
    `foreignTable` - the name of the table that imports the key; must match the table name as it is stored in the database
  Returns:
    `ResultSet` - each row is a foreign key column description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`, `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### getTypeInfo

    public java.sql.ResultSet getTypeInfo()
                                   throws java.sql.SQLException

  Retrieves a description of all the standard SQL types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

  Each type description has the following columns:

  1. TYPE_NAME String => Type name
  2. DATA_TYPE short => SQL data type from java.sql.Types
  3. PRECISION int => maximum precision
  4. LITERAL_PREFIX String => prefix used to quote a literal (may be `null`)
  5. LITERAL_SUFFIX String => suffix used to quote a literal (may be `null`)
  6. CREATE_PARAMS String => parameters used in creating the type (may be `null`)
  7. NULLABLE short => can you use NULL for this type.
     - typeNoNulls - does not allow NULL values
     - typeNullable - allows NULL values
     - typeNullableUnknown - nullability unknown
  8. CASE_SENSITIVE boolean=> is it case sensitive.
  9. SEARCHABLE short => can you use "WHERE" based on this type:
     - typePredNone - No support
     - typePredChar - Only supported with WHERE .. LIKE
     - typePredBasic - Supported except for WHERE .. LIKE
     - typeSearchable - Supported for all WHERE ..
  10. UNSIGNED_ATTRIBUTE boolean => is it unsigned.
  11. FIXED_PREC_SCALE boolean => can it be a money value.
  12. AUTO_INCREMENT boolean => can it be used for an auto-increment value.
  13. LOCAL_TYPE_NAME String => localized version of type name (may be `null`)
  14. MINIMUM_SCALE short => minimum scale supported
  15. MAXIMUM_SCALE short => maximum scale supported
  16. SQL_DATA_TYPE int => unused
  17. SQL_DATETIME_SUB int => unused
  18. NUM_PREC_RADIX int => usually 2 or 10

  ### HSQLDB-Specific Information:

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getTypeInfo` in interface `java.sql.DatabaseMetaData`
  Returns:
    a `ResultSet` object in which each row is an SQL type description
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getIndexInfo

    public java.sql.ResultSet getIndexInfo(java.lang.String catalog,
                                           java.lang.String schema,
                                           java.lang.String table,
                                           boolean unique,
                                           boolean approximate)
                                    throws java.sql.SQLException

  Retrieves a description of the given table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

  Each index column description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. NON_UNIQUE boolean => Can index values be non-unique. false when TYPE is tableIndexStatistic
  5. INDEX_QUALIFIER String => index catalog (may be `null`); `null` when TYPE is tableIndexStatistic
  6. INDEX_NAME String => index name; `null` when TYPE is tableIndexStatistic
  7. TYPE short => index type:
     - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
     - tableIndexClustered - this is a clustered index
     - tableIndexHashed - this is a hashed index
     - tableIndexOther - this is some other style of index
  8. ORDINAL_POSITION short => column sequence number within index; zero when TYPE is tableIndexStatistic
  9. COLUMN_NAME String => column name; `null` when TYPE is tableIndexStatistic
  10. ASC_OR_DESC String => column sort sequence, "A" => ascending, "D" => descending, may be `null` if sort sequence is not supported; `null` when TYPE is tableIndexStatistic
  11. CARDINALITY int => When TYPE is tableIndexStatistic, then this is the number of rows in the table; otherwise, it is the number of unique values in the index.
  12. PAGES int => When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
  13. FILTER_CONDITION String => Filter condition, if any. (may be `null`)

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getIndexInfo` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in this database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in this database
    `unique` - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
    `approximate` - when true, result is allowed to reflect approximate or out of date values; when false, results are requested to be accurate
  Returns:
    `ResultSet` - each row is an index column description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### supportsResultSetType

    public boolean supportsResultSetType(int type)
                                  throws java.sql.SQLException

  Retrieves whether this database supports the given result set type.

  Specified by:
    `supportsResultSetType` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)
  See Also:
    `jdbcConnection`

### supportsResultSetConcurrency

    public boolean supportsResultSetConcurrency(int type,
                                                int concurrency)
                                         throws java.sql.SQLException

  Retrieves whether this database supports the given concurrency type in combination with the given result set type.

  Specified by:
    `supportsResultSetConcurrency` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - defined in `java.sql.ResultSet`
    `concurrency` - type defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)
  See Also:
    `jdbcConnection`

### ownUpdatesAreVisible

    public boolean ownUpdatesAreVisible(int type)
                                 throws java.sql.SQLException

  Retrieves whether for the given type of `ResultSet` object, the result set's own updates are visible.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `ownUpdatesAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if updates are visible for the given result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### ownDeletesAreVisible

    public boolean ownDeletesAreVisible(int type)
                                 throws java.sql.SQLException

  Retrieves whether a result set's own deletes are visible.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `ownDeletesAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if deletes are visible for the given result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### ownInsertsAreVisible

    public boolean ownInsertsAreVisible(int type)
                                 throws java.sql.SQLException

  Retrieves whether a result set's own inserts are visible.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `ownInsertsAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if inserts are visible for the given result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### othersUpdatesAreVisible

    public boolean othersUpdatesAreVisible(int type)
                                    throws java.sql.SQLException

  Retrieves whether updates made by others are visible.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `othersUpdatesAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if updates made by others are visible for the given result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### othersDeletesAreVisible

    public boolean othersDeletesAreVisible(int type)
                                    throws java.sql.SQLException

  Retrieves whether deletes made by others are visible.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `othersDeletesAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if deletes made by others are visible for the given result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### othersInsertsAreVisible

    public boolean othersInsertsAreVisible(int type)
                                    throws java.sql.SQLException

  Retrieves whether inserts made by others are visible.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `othersInsertsAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if inserts made by others are visible for the given result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### updatesAreDetected

    public boolean updatesAreDetected(int type)
                               throws java.sql.SQLException

  Retrieves whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `updatesAreDetected` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if changes are detected by the result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### deletesAreDetected

    public boolean deletesAreDetected(int type)
                               throws java.sql.SQLException

  Retrieves whether or not a visible row delete can be detected by calling the method `ResultSet.rowDeleted`. If the method `deletesAreDetected` returns `false`, it means that deleted rows are removed from the result set.

  ### HSQLDB-Specific Information:

  Including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `deletesAreDetected` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if deletes are detected by the given result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### insertsAreDetected

    public boolean insertsAreDetected(int type)
                               throws java.sql.SQLException

  Retrieves whether or not a visible row insert can be detected by calling the method `ResultSet.rowInserted`.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support updateable result sets; this method always returns `false`.

  Specified by:
    `insertsAreDetected` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if changes are detected by the specified result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### supportsBatchUpdates

    public boolean supportsBatchUpdates()
                                 throws java.sql.SQLException

  Retrieves whether this database supports batch updates.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, HSQLDB supports batch updates; this method always returns `true`.

  Specified by:
    `supportsBatchUpdates` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if this database supports batch upcates; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### getUDTs

    public java.sql.ResultSet getUDTs(java.lang.String catalog,
                                      java.lang.String schemaPattern,
                                      java.lang.String typeNamePattern,
                                      int[] types)
                               throws java.sql.SQLException

  Retrieves a description of the user-defined types (UDTs) defined in a particular schema. Schema-specific UDTs may have type `JAVA_OBJECT`, `STRUCT`, or `DISTINCT`.

  Only types matching the catalog, schema, type name and type criteria are returned. They are ordered by DATA_TYPE, TYPE_SCHEM and TYPE_NAME. The type name parameter may be a fully-qualified name. In this case, the catalog and schemaPattern parameters are ignored.

  Each type description has the following columns:

  1. TYPE_CAT String => the type's catalog (may be `null`)
  2. TYPE_SCHEM String => type's schema (may be `null`)
  3. TYPE_NAME String => type name
  4. CLASS_NAME String => Java class name
  5. DATA_TYPE String => type value defined in java.sql.Types. One of JAVA_OBJECT, STRUCT, or DISTINCT
  6. REMARKS String => explanatory comment on the type
  7. BASE_TYPE short => type code of the source type of a DISTINCT type or the type that implements the user-generated reference type of the SELF_REFERENCING_COLUMN of a structured type as defined in java.sql.Types (`null` if DATA_TYPE is not DISTINCT or not STRUCT with REFERENCE_GENERATION = USER_DEFINED)

  Note: If the driver does not support UDTs, an empty result set is returned.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Up to and including 1.7.1, HSQLDB does not support UDTs and thus produces an empty result.

  Starting with 1.7.2, there is an option to support this feature to greater or lesser degrees. See the documentation specific to the selected system table provider implementation. The default implementation is org.hsqldb.DatabaseInformationFull.

  Specified by:
    `getUDTs` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema pattern name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `typeNamePattern` - a type name pattern; must match the type name as it is stored in the database; may be a fully qualified name
    `types` - a list of user-defined types (JAVA_OBJECT, STRUCT, or DISTINCT) to include; `null` returns all types
  Returns:
    `ResultSet` object in which each row describes a UDT
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### getConnection

    public java.sql.Connection getConnection()
                                      throws java.sql.SQLException

  Retrieves the connection that produced this metadata object.

  Specified by:
    `getConnection` in interface `java.sql.DatabaseMetaData`
  Returns:
    the connection that produced this metadata object
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcDatabaseMetaData)

### supportsSavepoints

    public boolean supportsSavepoints()
                               throws java.sql.SQLException

  Retrieves whether this database supports savepoints.

  ### HSQLDB-Specific Information:

  Beginning with 1.7.2, this SQL feature is supported through JDBC as well as SQL.

  Specified by:
    `supportsSavepoints` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if savepoints are supported; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### supportsNamedParameters

    public boolean supportsNamedParameters()
                                    throws java.sql.SQLException

  Retrieves whether this database supports named parameters to callable statements.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, HSQLDB supports JDBC named parameters to callable statements; this method returns true.

  Specified by:
    `supportsNamedParameters` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if named parameters are supported; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### supportsMultipleOpenResults

    public boolean supportsMultipleOpenResults()
                                        throws java.sql.SQLException

  Retrieves whether it is possible to have multiple `ResultSet` objects returned from a `CallableStatement` object simultaneously.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support multiple ResultSet objects returned from a `CallableStatement` object at all; this method always returns `false`.

  Specified by:
    `supportsMultipleOpenResults` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if a `CallableStatement` object can return multiple `ResultSet` objects simultaneously; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### supportsGetGeneratedKeys

    public boolean supportsGetGeneratedKeys()
                                     throws java.sql.SQLException

  Retrieves whether auto-generated keys can be retrieved after a statement has been executed.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support retrieving autogenerated keys through the JDBC interface at all, although it is possible to retrieve them in a proprietary fashion; this method always returns `false`.

  Specified by:
    `supportsGetGeneratedKeys` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if auto-generated keys can be retrieved after a statement has executed; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getSuperTypes

    public java.sql.ResultSet getSuperTypes(java.lang.String catalog,
                                            java.lang.String schemaPattern,
                                            java.lang.String typeNamePattern)
                                     throws java.sql.SQLException

  Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database. Only the immediate super type sub type relationship is modeled.

  Only supertype information for UDTs matching the catalog, schema, and type name is returned. The type name parameter may be a fully-qualified name. When the UDT name supplied is a fully-qualified name, the catalog and schemaPattern parameters are ignored.

  If a UDT does not have a direct super type, it is not listed here. A row of the `ResultSet` object returned by this method describes the designated UDT and a direct supertype. A row has the following columns:

  1. TYPE_CAT String => the UDT's catalog (may be `null`)
  2. TYPE_SCHEM String => UDT's schema (may be `null`)
  3. TYPE_NAME String => type name of the UDT
  4. SUPERTYPE_CAT String => the direct super type's catalog (may be `null`)
  5. SUPERTYPE_SCHEM String => the direct super type's schema (may be `null`)
  6. SUPERTYPE_NAME String => the direct super type's name

  Note: If the driver does not support type hierarchies, an empty result set is returned.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Including 1.7.1, this JDBC feature is not supported; calling this method throws a SQLException stating that the operation is not supported.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getSuperTypes` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `typeNamePattern` - a UDT name pattern; may be a fully-qualified name
  Returns:
    a `ResultSet` object in which a row gives information about the designated UDT
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getSuperTables

    public java.sql.ResultSet getSuperTables(java.lang.String catalog,
                                             java.lang.String schemaPattern,
                                             java.lang.String tableNamePattern)
                                      throws java.sql.SQLException

  Retrieves a description of the table hierarchies defined in a particular schema in this database.

  Only supertable information for tables matching the catalog, schema and table name are returned. The table name parameter may be a fully- qualified name, in which case, the catalog and schemaPattern parameters are ignored. If a table does not have a super table, it is not listed here. Supertables have to be defined in the same catalog and schema as the sub tables. Therefore, the type description does not need to include this information for the supertable.

  Each type description has the following columns:

  1. TABLE_CAT String => the type's catalog (may be `null`)
  2. TABLE_SCHEM String => type's schema (may be `null`)
  3. TABLE_NAME String => type name
  4. SUPERTABLE_NAME String => the direct super type's name

  Note: If the driver does not support type hierarchies, an empty result set is returned.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getSuperTables` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern; may be a fully-qualified name
  Returns:
    a `ResultSet` object in which each row is a type description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getAttributes

    public java.sql.ResultSet getAttributes(java.lang.String catalog,
                                            java.lang.String schemaPattern,
                                            java.lang.String typeNamePattern,
                                            java.lang.String attributeNamePattern)
                                     throws java.sql.SQLException

  Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog.

  Descriptions are returned only for attributes of UDTs matching the catalog, schema, type, and attribute name criteria. They are ordered by TYPE_SCHEM, TYPE_NAME and ORDINAL_POSITION. This description does not contain inherited attributes.

  The `ResultSet` object that is returned has the following columns:

  1. TYPE_CAT String => type catalog (may be `null`)
  2. TYPE_SCHEM String => type schema (may be `null`)
  3. TYPE_NAME String => type name
  4. ATTR_NAME String => attribute name
  5. DATA_TYPE short => attribute type SQL type from java.sql.Types
  6. ATTR_TYPE_NAME String => Data source dependent type name. For a UDT, the type name is fully qualified. For a REF, the type name is fully qualified and represents the target type of the reference type.
  7. ATTR_SIZE int => column size. For char or date types this is the maximum number of characters; for numeric or decimal types this is precision.
  8. DECIMAL_DIGITS int => the number of fractional digits
  9. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
  10. NULLABLE int => whether NULL is allowed
      - attributeNoNulls - might not allow NULL values
      - attributeNullable - definitely allows NULL values
      - attributeNullableUnknown - nullability unknown
  11. REMARKS String => comment describing column (may be `null`)
  12. ATTR_DEF String => default value (may be `null`)
  13. SQL_DATA_TYPE int => unused
  14. SQL_DATETIME_SUB int => unused
  15. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
  16. ORDINAL_POSITION int => index of column in table (starting at 1)
  17. IS_NULLABLE String => "NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means unknown.
  18. SCOPE_CATALOG String => catalog of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
  19. SCOPE_SCHEMA String => schema of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
  20. SCOPE_TABLE String => table name that is the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
  21. SOURCE_DATA_TYPE short => source type of a distinct type or user-generated Ref type,SQL type from java.sql.Types (`null` if DATA_TYPE isn't DISTINCT or user-generated REF)

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive in SQL but stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All jdbcDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Including 1.7.1, this JDBC feature is not supported; calling this method throws a SQLException stating that the operation is not supported.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.DatabaseInformationFull or org.hsqldb.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getAttributes` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `typeNamePattern` - a type name pattern; must match the type name as it is stored in the database
    `attributeNamePattern` - an attribute name pattern; must match the attribute name as it is declared in the database
  Returns:
    a `ResultSet` object in which each row is an attribute description
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### supportsResultSetHoldability

    public boolean supportsResultSetHoldability(int holdability)
                                         throws java.sql.SQLException

  Retrieves whether this database supports the given result set holdability.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, HSQLDB returns true for HOLD_CURSORS_OVER_COMMIT, else false.

  Specified by:
    `supportsResultSetHoldability` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `holdability` - one of the following constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7
  See Also:
    `jdbcConnection`

### getResultSetHoldability

    public int getResultSetHoldability()
                                throws java.sql.SQLException

  Retrieves the default holdability of this `ResultSet` object.

  ### HSQLDB-Specific Information:

  Starting with HSQLDB 1.7.2, this JDBC feature is supported.

  Calling this method returns HOLD_CURSORS_OVER_COMMIT, since HSQLDB ResultSet objects are never closed as the result of an implicit or explicit commit operation.

  Specified by:
    `getResultSetHoldability` in interface `java.sql.DatabaseMetaData`
  Returns:
    the default holdability; either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getDatabaseMajorVersion

    public int getDatabaseMajorVersion()
                                throws java.sql.SQLException

  Retrieves the major version number of the underlying database.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, the feature is supported under JDK14 builds.

  This value is retrieved through an SQL call to the new `Library.getDatabaseMajorVersion` method which allows correct determination of the database major version for both local and remote database instances.

  Specified by:
    `getDatabaseMajorVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    the underlying database's major version
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getDatabaseMinorVersion

    public int getDatabaseMinorVersion()
                                throws java.sql.SQLException

  Retrieves the minor version number of the underlying database.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, the feature is supported under JDK14 builds.

  This value is retrieved through an SQL call to the new `Library.getDatabaseMinorVersion` method which allows correct determination of the database minor version for both local and remote database instances.

  Specified by:
    `getDatabaseMinorVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    underlying database's minor version
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getJDBCMajorVersion

    public int getJDBCMajorVersion()
                            throws java.sql.SQLException

  Retrieves the major JDBC version number for this driver.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, the feature is supported under JDK14 builds.

  Specified by:
    `getJDBCMajorVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC version major number
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getJDBCMinorVersion

    public int getJDBCMinorVersion()
                            throws java.sql.SQLException

  Retrieves the minor JDBC version number for this driver.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, the feature is supported under JDK14 builds.

  Specified by:
    `getJDBCMinorVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC version minor number
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getSQLStateType

    public int getSQLStateType()
                        throws java.sql.SQLException

  Indicates whether the SQLSTATEs returned by `SQLException.getSQLState` is X/Open (now known as Open Group) SQL CLI or SQL99.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, HSQLDB returns `sqlStateSQL99`.

  Specified by:
    `getSQLStateType` in interface `java.sql.DatabaseMetaData`
  Returns:
    the type of SQLSTATEs, one of: sqlStateXOpen or sqlStateSQL99
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### locatorsUpdateCopy

    public boolean locatorsUpdateCopy()
                               throws java.sql.SQLException

  Indicates whether updates made to a LOB are made on a copy or directly to the LOB.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB updates the LOB directly. This method return false.

  Specified by:
    `locatorsUpdateCopy` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if updates are made to a copy of the LOB; `false` if updates are made directly to the LOB
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### supportsStatementPooling

    public boolean supportsStatementPooling()
                                     throws java.sql.SQLException

  Retrieves whether this database supports statement pooling.

  ### HSQLDB-Specific Information:

  Up to and including 1.7.2, HSQLDB does not support statement pooling. This method returns false.

  Specified by:
    `supportsStatementPooling` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` is so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001 - 2005 HSQL Development Group. All Rights Reserved.